/* $Id: I3DEXCAM.H 1.5 1995/11/05 07:58:50 psq-pc Exp $ */
/*****************************************************************************\
*                                                                             *
* I3DExCam.h - I3DExCamera definition                         							  *
*                                                                             *
*           Copyright (c) 1995, Ray Dream, Inc. All rights reserved.          *
*                                                                             *
\*****************************************************************************/

#ifndef __I3DEXCAM__
#define __I3DEXCAM__

#ifndef __I3DEX__
#include "I3DEx.h"
#endif


//****** Globally Unique Ids *************************************************

DEFINE_GUID(IID_I3DExCamera, 0x9F338E00L, 0x3A02, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02);

/*****************************************************************************\
*  I3DExCamera                                                                *
*                                                                             *
*  Cameras                                                                    *
*                                                                             *
\*****************************************************************************/

#undef  INTERFACE
#define INTERFACE   I3DExCamera

DECLARE_INTERFACE_(I3DExCamera, I3DExDataExchanger) {
	// IUnknown methods
  STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
  STDMETHOD_(ULONG, AddRef) (THIS) PURE;
  STDMETHOD_(ULONG, Release) (THIS) PURE;
  
	// I3DExtension methods
	STDMETHOD_(I3DExtension*, Clone) (THIS) PURE;
	STDMETHOD(ShellUtilitiesInit) (THIS_ IShUtilities* shellUtilities) PURE;

  // I3DExDataExchanger methods
	STDMETHOD_(ExtensionDataMap*, GetExtensionDataMap) (THIS) PURE;
	STDMETHOD_(void*, GetExtensionDataBuffer) (THIS) PURE;
  STDMETHOD(ExtensionDataChanged) (THIS) PURE;
  STDMETHOD(HandleEvent) (THIS_ ULONG sourceID) PURE;
	STDMETHOD_(short, GetResID) (THIS) PURE;
  
  // I3DExCamera methods
	STDMETHOD(SetTransform) (THIS_ TRANSFORM3D* transform) PURE;
	STDMETHOD_(BOOLEAN, CreateRay) (THIS_ VECTOR2D* screenPosition, VECTOR3D* resultOrigin, VECTOR3D* resultDirection) PURE;
	STDMETHOD_(BOOLEAN, Project3DTo2D) (THIS_ VECTOR3D* position, VECTOR2D* resultScreenPosition, NUM3D* resultDistanceToScreen) PURE;
	STDMETHOD_(ULONG, GetPrimitiveID) (THIS) PURE;
	STDMETHOD_(ULONG, Clip3D) (THIS_  FACET3D* localFacet, VERTEX3D* localVertices,
																		FACET3D* cameraFacet, VERTEX3D* cameraVertices,
																		NUM3D* clipBox) PURE;
	STDMETHOD_(BOOLEAN, ClipLine3D) (THIS_ VECTOR3D* P1, VECTOR3D* P2) PURE;
	};
#endif
