/* $Id: I3DEXLNK.H 1.3 1995/09/19 03:01:36 PascalF Exp $ */
/*****************************************************************************\
*                                                                             *
* I3DExLnk.h - 	I3DExMotionLink definition                    							  *
*                                                                             *
*           Copyright (c) 1995, Ray Dream, Inc. All rights reserved.          *
*                                                                             *
\*****************************************************************************/

#ifndef __I3DEXLNK__
#define __I3DEXLNK__

#ifndef __I3DEX__
#include "I3DEx.h"
#endif


//****** Globally Unique Ids *************************************************

DEFINE_GUID(IID_I3DExMotionLink, 0x5C9601A0L, 0x7CC3, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02);

/*****************************************************************************\
*  I3DExMotionLink                                                            *
*                                                                             *
*  Motion Links between Tree Elements                                         *
*                                                                             *
\*****************************************************************************/

#undef  INTERFACE
#define INTERFACE   I3DExMotionLink

DECLARE_INTERFACE_(I3DExMotionLink, I3DExDataExchanger) {
	// IUnknown methods
  STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
  STDMETHOD_(ULONG, AddRef) (THIS) PURE;
  STDMETHOD_(ULONG, Release) (THIS) PURE;
  
	// I3DExtension methods
	STDMETHOD_(I3DExtension*, Clone) (THIS) PURE;
	STDMETHOD(ShellUtilitiesInit) (THIS_ IShUtilities* shellUtilities) PURE;

  // I3DExDataExchanger methods
	STDMETHOD_(ExtensionDataMap*, GetExtensionDataMap) (THIS) PURE;
	STDMETHOD_(void*, GetExtensionDataBuffer) (THIS) PURE;
  STDMETHOD(ExtensionDataChanged) (THIS) PURE;
  STDMETHOD(HandleEvent) (THIS_ ULONG sourceID) PURE;
	STDMETHOD_(short, GetResID) (THIS) PURE;
  
  // I3DExMotionLink methods
	STDMETHOD_(short, GetNbrFreedom) (THIS) PURE;
  STDMETHOD(IncrementFreedomValue) (THIS_ short index, NUM3D* increment) PURE;
  STDMETHOD(GetFreedomRange) (THIS_ short index, NUM3D* min, NUM3D* max) PURE;
	STDMETHOD(GetTransform) (THIS_ TRANSFORM3D* transform) PURE;
	STDMETHOD(GetTransformPartialDerivate)(THIS_ short index, TRANSFORM3D* transform) PURE;
	};

#endif
