/* $Id: I3DEXTBH.H 1.8 1997/04/18 01:24:29 joshua-pc Exp $ */
/*****************************************************************************\
*                                                                             *
* I3DExTBh.h - 	I3DExTreeBehavior definition                    						  *
*                                                                             *
*           Copyright (c) 1995, Ray Dream, Inc. All rights reserved.          *
*                                                                             *
\*****************************************************************************/

#ifndef __I3DEXTBH__
#define __I3DEXTBH__

#ifndef __I3DEX__
#include "I3DEx.h"
#endif

#ifndef __I3DSHTRE__
#include "I3DShTre.h"
#endif

//****** Globally Unique Ids *************************************************

DEFINE_GUID(IID_I3DExTreeBehavior, 0x5C9601A1L, 0x7CC3, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02);
DEFINE_GUID(IID_I3DExTreeBehavior10, 0x8c9c1b40, 0x9bae, 0x11d0, 0x88, 0xa9, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0);

/*****************************************************************************\
*  I3DExTreeBehavior                                                          *
*                                                                             *
*  Tree Elements Behavior                                                     *
*                                                                             *
\*****************************************************************************/

#define kTreeBehaviorRemoveTransformTrack 1
#define kTreeBehaviorLockSetTransform 2

#undef  INTERFACE
#define INTERFACE   I3DExTreeBehavior

DECLARE_INTERFACE_(I3DExTreeBehavior, I3DExDataExchanger) {
	// IUnknown methods
  STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
  STDMETHOD_(ULONG, AddRef) (THIS) PURE;
  STDMETHOD_(ULONG, Release) (THIS) PURE;
  
	// I3DExtension methods
	STDMETHOD_(I3DExtension*, Clone) (THIS) PURE;
	STDMETHOD(ShellUtilitiesInit) (THIS_ IShUtilities* shellUtilities) PURE;

  // I3DExDataExchanger methods
	STDMETHOD_(ExtensionDataMap*, GetExtensionDataMap) (THIS) PURE;
	STDMETHOD_(void*, GetExtensionDataBuffer) (THIS) PURE;
  STDMETHOD(ExtensionDataChanged) (THIS) PURE;
  STDMETHOD(HandleEvent) (THIS_ ULONG sourceID) PURE;
	STDMETHOD_(short, GetResID) (THIS) PURE;
  
  // I3DExTreeBehavior methods
	STDMETHOD(Apply) (THIS_ I3DShTreeElement* tree) PURE;
	};

#undef  INTERFACE
#define INTERFACE   I3DExTreeBehavior10

DECLARE_INTERFACE_(I3DExTreeBehavior10, I3DExTreeBehavior) {
  // I3DExTreeBehavior10 methods
	STDMETHOD_(long, GetFlags) (THIS) PURE;
	};

#endif
