/* $Id: I3DSHAB.H 1.6 1997/04/26 00:03:27 damien Exp $ */
/*****************************************************************************\
*                                                                             *
* I3DShAB.h - 	                 			                              				  *
*   I3DShEnvironment definition                                               *
*                                                                             *
*           Copyright (c) 1995, Ray Dream, Inc. All rights reserved.          *
*                                                                             *
\*****************************************************************************/

#ifndef __I3DSHAB__
#define __I3DSHAB__

#ifndef __3DCOTYPE__
#include "3DCoType.h"
#endif

//****** Globally Unique Ids *************************************************

DEFINE_GUID(IID_I3DShEnvironment, 0xA0629720L, 0x3A0D, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02);


/*****************************************************************************\
*  I3DShEnvironment                                                           *
*                                                                             *
*  Environment as seen from other extensions                                  *
*                                                                             *
\*****************************************************************************/

//C++ API Only !!!!!

DECLARE_INTERFACE_(I3DShEnvironment, IUnknown) {
	STDMETHOD(SegmentFilter) (const VECTOR3D &beg,const VECTOR3D &end,COLOR3D &filterOut) PURE;
	STDMETHOD(DirectionFilter) (const VECTOR3D &origin,const VECTOR3D &direction, COLOR3D &filterOut) PURE;
	STDMETHOD(GetBackdropColor) (const VECTOR2D &screenPoint,const BOX2D &screenMinMax, COLOR3D &resultColor) PURE;
	STDMETHOD(GetEnvironmentColor) (const VECTOR3D &direction, COLOR3D &resultColor, BOOLEAN &result) PURE;
	STDMETHOD_(Boolean, HasAtmosphere) () const PURE;
	STDMETHOD_(Boolean, HasBackdrop) () const PURE;
	STDMETHOD_(Boolean, HasBackground) () const PURE;
	};






#endif
