/* $Id: I3DShWSc.H 1.1 1997/03/31 20:10:16 damien Exp $ */
/*****************************************************************************\
*                                                                             *
* I3DShWSc.h                                                  							  *
*   I3DShWritableScene definition                                             *
*                                                                             *
*           Copyright (c) 1995, Ray Dream, Inc. All rights reserved.          *
*                                                                             *
\*****************************************************************************/

#ifndef __I3DSHWSC__
#define __I3DSHWSC__

#ifndef __I3DSHOBJ__
#include "I3DShObj.h"
#endif

#ifndef __I3DSHTRE__
#include "I3DShTre.h"
#endif

//****** Globally Unique Ids **************************************************

// {2FCCB700-A6D3-11d0-94E4-0000C0E44587}
DEFINE_GUID(IID_I3DShWritableScene, 0x2FCCB700L, 0xA6D3, 0x11D0, 0x94, 0xE4, 0x00, 0x00, 0xC0, 0xE4, 0x45, 0x87);

/*****************************************************************************\
*  I3DShWritableScene                                                         *
*                                                                             *
*    Topmost data structure that contains all the data of a scene.            *
*                                                                             *
\*****************************************************************************/

#undef  INTERFACE
#define INTERFACE   I3DShWritableScene

DECLARE_INTERFACE_(I3DShWritableScene, IUnknown) {
	// IUnknown methods
  STDMETHOD(QueryInterface) (THIS_ REFIID riid, LPVOID FAR* ppvObj) PURE;
  STDMETHOD_(ULONG, AddRef) (THIS) PURE;
  STDMETHOD_(ULONG, Release) (THIS) PURE;

	// I3DShWritableScene methods
	STDMETHOD(DoWrite) (THIS_ I3DShTreeElement* fatherTree, Riostream* stream, IShRasterOffscreen* preview,
		BOOLEAN writeALLobjects, char* fullPathName, short versionNumber, long geometryMode, NUM3D silhouette) PURE;
	STDMETHOD(DoRead) (THIS_ Riostream* stream, char* fullPathName) PURE;
	STDMETHOD(DoNeedDiskSpace)(THIS_ long* dataForkSize) PURE;
	};

#endif

