#ifndef __XAPIR__
#define __XAPIR__
//$Id: XAPI.R 1.15 1997/07/02 21:02:54 Pierre-PP Exp $

#define kRDAPIVersion 9

type 'GUID' {
	array TypeArray { 
		hex longint;
		hex integer;
		hex integer;
		hex string[8];
		};
	};

type 'COMP' {
	literal longint;					/* Family		    	*/
	literal longint;					/* Class		    	*/
	pstring[63];							/* Name           */
	pstring[63];							/* SubFamily Name	*/
	hex longint;							/* Engine version  $xxxx.yy.zz example: 3.1.2 gives 0x00030102 */
	pstring[31];							/* Version string */
	pstring[255];							/* Comment	      */
	longint;									/* API number on which the engine is based */
	};

// Old type of Comp resource (prior to the implementation of the API numbering scheme) */
// DO NOT USE
type 'Comp' {
		literal longint;				/* Family			*/
		literal longint;				/* Class			*/
		pstring[63];						/* Name				*/
		pstring[63];						/* SubFamily Name	*/
		literal longint;				/* version			*/
		pstring[31];						/*Version string	*/
		pstring[255];						/* Comment	*/
};

type 'PMAP' {
		array TypeArray { 
			literal longint;
			literal longint;
			};
	};

//new type of pMAP for animation
type 'pMAP' {
		array TypeArray { 
			literal longint;	
			literal longint;
			longint;
			pstring[31];
			};
	};
#define interpolate 1
#define paramReadOnly 2
#define noFlags 0

type 'Modu' {
	literal longint;				/* Family */
	literal longint;				/* Class */
	pstring[63];						/* Name */
	pstring[63];						/* SubFamily Name */
	literal int;						/* WindowID */
	literal int;						/* MBarID */
	literal int;						/* TBarID */
	literal int;						/* PrefsMappingResID */
	literal int;						/* PrefsViewResID */
	literal int;						/* DefaultPrefsResID */
	literal longint;				/* Workspace class signature */
	literal longint;				/* version */
	pstring[31];						/* Version string */
	pstring[255];						/* Comment */
	literal int;						/* minimized iconID */
	literal longint;				/* window context menuID or -1 */
	literal int;						/* boolean: is document module, used for external modules */
	};

#define isAlienType 0
#define isMainType 1
#define hasExportOptions 2

type 'Cmpp'	{							/* 'I/O' private data */
	longint;								/* Family Signature */
	longint;								/* Class Signature */
	longint;								/* flags */
	literal longint;				/* creator (for Macintosh exporters only) */

	integer = $$CountOf(TypeArray);		/* Number of types		*/ \
	wide array TypeArray{	\
		literal longint;								/* Reference */	\
		cstring;												/* Name	*/ \
		integer = $$CountOf(MacTypeArray); \
		wide array MacTypeArray{ \
			literal longint;							/* Mac type  */ \
			}; \
		integer = $$CountOf(ExtTypeArray); \
		wide array ExtTypeArray{ \
			literal longint;							/* Extension (last char ignored)  */ \
			}; \
		};
	};

type 'prfs'	{
	cstring;
};

type 'prwk'	{
	cstring;
};

// Cross Platform View
type 'XPVW' {
	cstring;
};

#endif