// Copyright (c)1995 Ray Dream, Inc. All Rights Reserved.
/*$Id: COMDefX.h 1.4 1997/05/12 19:01:26 damien Exp $*/

//
// COM Example of Deformer
//

#ifndef __COMDEFX__
#define __COMDEFX__  

#ifndef __I3DEXDFR__
#include "I3DExDfr.h"
#endif

struct IShFacetMeshAccumulator;
                  
// define the Deformer CLSID
// {B5DF8B40-FD8F-11ce-A4F7-0000E202D5A5}
DEFINE_GUID(CLSID_COMDeformer,0xb5df8b40,0xfd8f,0x11ce,0xa4,0xf7,0x0,0x0,0xe2,0x2,0xd5,0xa5);


typedef struct DeformerData {
  NUM3D fMinSize;
  NUM3D fExplosionFactor;
  short fGravityOrNotGravity;
  NUM3D fFloor;
  NUM3D fGravityCoef;
  BOX3D fBoundingBox;  // Bounding Box
  } DeformerData;

// Number Maximum of subdivisions of a Facet
#define SPLITMAX 8

// Deformer Object :
#undef INTERFACE
#define INTERFACE Deformer
class Deformer : public I3DExDeformer2, I3DExDataExchanger {
public :  
  Deformer();
  ~Deformer();
  
  // IUnknown Interface :
  STDMETHODIMP         QueryInterface(THIS_ REFIID riid, LPVOID* ppvObj);
  STDMETHODIMP_(ULONG) AddRef(THIS);
  STDMETHODIMP_(ULONG) Release(THIS);
  
  // I3DExtension method :
  STDMETHODIMP_(I3DExtension*) Clone(THIS);
  STDMETHODIMP                 ShellUtilitiesInit(THIS_ IShUtilities* shellUtilities);  
  
  // I3DExDataExchanger methods :
  STDMETHODIMP_(ExtensionDataMap*) GetExtensionDataMap(THIS);
  STDMETHODIMP_(void*)             GetExtensionDataBuffer(THIS);
  STDMETHODIMP                     ExtensionDataChanged(THIS);
  STDMETHODIMP                     HandleEvent(THIS_ ULONG sourceID);
  STDMETHODIMP_(short)             GetResID(THIS);
  
  // I3DExDeformer methods :
  STDMETHODIMP  SetBBox(THIS_ BOX3D* bbox);
  STDMETHODIMP  DeformPoint(THIS_ VECTOR3D* point, VECTOR3D* result);
	STDMETHODIMP  DeformFacetMesh(THIS_ NUM3D lod,const FacetMesh &in,FacetMesh &out);
	STDMETHODIMP  DeformBBox(THIS_ const BOX3D &in, BOX3D& out);
private :
  ULONG         fCRef;         // reference Counter
  DeformerData  fData;         // Deformer Data
	void explodeFacet(const FACET3D *aFacet, IShFacetMeshAccumulator* accu, short level=0);
  void moveFacet(FACET3D *aFacet);
  };


#endif
