/* $Id: COMImp.h 1.6 1997/05/21 18:28:46 damien Exp $ */

// Copyright  1990-1995 Ray Dream, Inc. All rights reserved.

#ifndef __COMIMP__
#define __COMIMP__

#ifndef __I3DEXIO__
#include "I3DExIO.h"
#endif

#ifndef __IMPDATA__
#include "IMPData.h"
#endif

struct IShFileStream;
struct I3DShScene;
struct I3DShTreeElement;
struct I3DShObject;

//DEFINE_GUID(CLSID_DxfOut, 0x5C9601ABL, 0x7CC3, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02);
//DEFINE_GUID(CLSID_DxfIn, 0x5C9601AAL, 0x7CC3, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02);
// {395C54E0-EED9-11cf-9A2C-0020AF28193A}
DEFINE_GUID(CLSID_EasyIn, 0x395c54e0, 0xEED9, 0x11CF, 0x9A, 0x2C, 0x00, 0x20, 0xAF, 0x28, 0x19, 0x3A);


#undef INTERFACE
#define INTERFACE TEasyImporter
class TEasyImporter : public I3DExImportFilter {
public:
	TEasyImporter();
	~TEasyImporter();

	// IUnknown Interface :
	STDMETHODIMP				 QueryInterface(THIS_ REFIID riid, LPVOID* ppvObj);
	STDMETHODIMP_(ULONG) AddRef(THIS);
	STDMETHODIMP_(ULONG) Release(THIS);

	// I3DExtension method :
	STDMETHODIMP_(I3DExtension*) Clone(THIS);
	STDMETHODIMP								 ShellUtilitiesInit(THIS_ IShUtilities* shellUtilities);

	// I3DExDataExchanger methods :
	STDMETHODIMP_(ExtensionDataMap*) GetExtensionDataMap(THIS);
	STDMETHODIMP_(void*)						 GetExtensionDataBuffer(THIS);
	STDMETHODIMP										 ExtensionDataChanged(THIS);
	STDMETHODIMP										 HandleEvent(THIS_ ULONG sourceD);
	STDMETHODIMP_(short)						 GetResID(THIS);

	// I3DExImportFilter
	STDMETHODIMP_(BOOLEAN) Prepare(THIS_ char* fullPathName, I3DShScene* scene, I3DShTreeElement* fatherTree);
	STDMETHODIMP_(BOOLEAN) WantsOptionDialog(THIS);
	STDMETHODIMP DoImport(THIS_ char* fullPathName, I3DShScene* scene, I3DShTreeElement* fatherTree);
	STDMETHODIMP_(BOOLEAN) WantsTopScene(THIS);

protected:
	void StartProgress(IShFileStream* afile);
	void DoReadEasyFile(IShFileStream* stream, I3DShScene* scene, I3DShTreeElement* topTree);
	TfData			fData;

	I3DShScene*	fScene;
	long				fProgressMax;
	
private:
	ULONG				fCRef;
	};

#endif