// Copyright (c)1995 Ray Dream, Inc. All Rights Reserved.
/* $Id: xcomlite.r 1.1 1997/07/11 22:46:18 damien Exp $ */

#define NOFLAG 0L
#define INTERPOLATE 1L

#define MINQF16 0xFFFF8000L
#define MAXQF16 0x00007FFFL
#define MINQFIX 0xFFFF8000L
#define MAXQFIX 0x00007FFFL

132 COMP DISCARDABLE
BEGIN
	"lite",           // family ID
	"CObl",          // unique creator
	"Beams Light\0",			// name of the extension
	"COM Examples\0",  // sub family (used for shaders and scene operations)
	"3.1.3\0",        // version number
	"Toolkit COM Example\0", // comments
	0x0009L           // minimum API version number required
END

132 PMAP DISCARDABLE 
BEGIN
	//  structure of a PMAP entry:
	//"4lID","type",INTERPOLATE or NOFLAG,"Description\0",minValue,maxValue
	//  ex:
    //"COLO","colo",INTERPOLATE,"Color\0",0L,0L,
    //"ZMIN","qf16",INTERPOLATE,"Min Altitude\0",MINQF16,MAXQF16,
    //"ZMAX","qf16",INTERPOLATE,"Max Altitude\0",MINQF16,MAXQF16,
    //"VISI","qf16",INTERPOLATE,"Visibility\0",0L,MAXQF16
	0x0007, // number of entries, increment it when you add an entry
	"HAAN","shrt",INTERPOLATE,"Hor. Aperture\0",MINQF16,MAXQF16,
	"VAAN","shrt",INTERPOLATE,"Ver. Aperture\0",MINQF16,MAXQF16,
	"INTE","qfix",INTERPOLATE,"Intensity\0",MINQF16,MAXQF16,
	"NBBH","shrt",INTERPOLATE,"# Hor. Beams\0",MINQF16,MAXQF16,
	"NBBV","shrt",INTERPOLATE,"# Ver. Beams\0",MINQF16,MAXQF16,
	"COLO","colo",INTERPOLATE,"Color\0",MINQF16,MAXQF16,
	"BEAP","shrt",INTERPOLATE,"Beam Aperture\0",MINQF16,MAXQF16
END

132 GUID DISCARDABLE 
BEGIN
// from	a GUID in a DTA $"ABCD EFGH IJKL MNOP QRST UVWX YZ12 3456"
// change to 0xEFGH, 0xABCD, 0xIJKL, 0xMNOP, 0xSTQR, 0xWXUV, 0x12YZ, 0x5634
	0xED80, 0xA930, 0x3A02, 0x101C, 0x5F88, 0x0204, 0x001C, 0x0270
	0x2360, 0xF347, 0x734D, 0x101C, 0x01B8, 0x0204, 0x001C, 0x0270
END

132 XPVW DISCARDABLE
BEGIN
  //  VIEW resource: no null character allowed !!!
"\043 exploder bis
View {
 PosX 0
 PosY 0
 SizX 404
 SizY 199
 VwId EDIT
 Stat {
  PosX 8
	PosY 6
	SizX 93
	SizY 14
	Bold 1
	Capt \042Beams Light\042
  }
 Stat {
  PosX 8
	PosY 29
	SizX 54
	SizY 16
	Capt \042Color:\042
  }
 Colo {
  PosX 69
	PosY 26
	SizX 58
	SizY 24
	VwId COLO
  }
 Stat {
  PosX 118
	PosY 67
	SizX 73
	SizY 16
	Capt \042Intensity\042
  }
 Slid {
  PosX 8
	PosY 66
	SizX 100
	SizY 20
	User 2002
	MinV 0
	MaxV 131072
	VwId INTE
  }
 Stat {
  PosX 118
	PosY 91
	SizX 99
	SizY 16
	Capt \042Horizontal Aperture\042
  }
 Slid {
  PosX 8
	PosY 90
	SizX 100
	SizY 20
	User 2003
	MinV 1
	MaxV 360
	VwId HAAN
  }
 Stat {
  PosX 118
	PosY 112
	SizX 100
	SizY 16
	Capt \042Vertical Aperture\042
  }
 Slid {
  PosX 8
	PosY 110
	SizX 100
	SizY 20
	User 2003
	MinV 1
	MaxV 180
	VwId VAAN
  }
 Stat {
  PosX 118
	PosY 144
	SizX 138
	SizY 16
	Capt \042Number of Horizontal Beams\042
  }
 Slid {
  PosX 8
	PosY 143
	SizX 100
	SizY 20
	User 2003
	MinV 1
	MaxV 20
	VwId NBBH
  }
 Stat {
  PosX 118
	PosY 165
	SizX 138
	SizY 16
	Capt \042Number of Vertical Beams\042
  }
 Slid {
  PosX 8
	PosY 163
	SizX 100
	SizY 20
	User 2003
	MinV 1
	MaxV 20
	VwId NBBV
  }
 Stat {
  PosX 323
	PosY 100
	SizX 73
	SizY 16
	Capt \042Beam Aperture\042
  }
 Slid {
  PosX 216
	PosY 99
	SizX 100
	SizY 20
	User 2003
	MinV 1
	MaxV 60
	VwId BEAP
  }
 }
\0"
END

